# Google Docstrings code sample

```python
"""Example Google style docstrings.

This code demonstrates documentation as specified by the Google Python
Style Guide. Docstrings may extend over multiple lines. Sections are created
with a section header and a colon followed by a block of indented text.

Example:
    Examples can be given using either the ``Example`` or ``Examples``
    sections. Sections support any reStructuredText formatting, including
    literal blocks::

        $ python example_google.py

Section breaks are created by resuming unindented text. Section breaks
are also implicitly created anytime a new section starts.

"""

from typing import List


module_level_variable: int = 12345
"""Module level variable are documented inline.

The docstring may span multiple lines. The type is hinted.
"""

def module_level_function(param1: int, param2: str = None, *args, **kwargs):
    """This is an example of a module level function.

    Function parameters should be documented in the ``Args`` section. The name
    of each parameter is required. The description of each parameter
    is optional, but should be included if not obvious.

    If \*args or \*\*kwargs are accepted,
    they should be listed as ``*args`` and ``**kwargs``.

    The format for a parameter is::

        name: description
            The description may span multiple lines. Following
            lines should be indented. The "(type)" is optional.

            Multiple paragraphs are supported in parameter
            descriptions.

    Args:
        param1: The first parameter.
        param2: The second parameter. Defaults to None.
            Second line of description should be indented.
        *args: Variable length argument list.
        **kwargs: Arbitrary keyword arguments.

    Returns:
        True if successful, False otherwise.

        The ``Returns`` section may span multiple lines and paragraphs.
        Following lines should be indented to match the first line.

        The ``Returns`` section supports any reStructuredText formatting,
        including literal blocks::

            {
                'param1': param1,
                'param2': param2
            }

    Raises:
        AttributeError: The ``Raises`` section is a list of all exceptions
            that are relevant to the interface.
        ValueError: If `param2` is equal to `param1`.

    """
    if param1 == param2:
        raise ValueError('param1 may not be equal to param2')
    return True


def example_generator(n: int):
    """Generators have a ``Yields`` section instead of a ``Returns`` section.

    Args:
        n: The upper limit of the range to generate, from 0 to `n` - 1.

    Yields:
        int: The next number in the range of 0 to `n` - 1.

    Examples:
        Examples should be written in doctest format, and should illustrate how
        to use the function.

        >>> print([i for i in example_generator(4)])
        [0, 1, 2, 3]

    """
    for i in range(n):
        yield i


class ExampleError(Exception):
    """Exceptions are documented in the same way as classes.

    The __init__ method may be documented in either the class level
    docstring, or as a docstring on the __init__ method itself.

    Either form is acceptable, but the two should not be mixed. Choose one
    convention to document the __init__ method and be consistent with it.

    Note:
        Do not include the `self` parameter in the ``Args`` section.

    Args:
        msg: Human readable string describing the exception.
        code: Error code.

    Attributes:
        msg: Human readable string describing the exception.
        code: Exception error code.

    """
    msg: str
    code: int

    def __init__(self, msg: str, code: int):
        self.msg = msg
        self.code = code


class ExampleClass(object):
    """The summary line for a class docstring should fit on one line.

    If the class has public attributes, they may be documented here
    in an ``Attributes`` section and follow the same formatting as a
    function's ``Args`` section. Alternatively, attributes may be documented
    inline with the attribute's declaration (see __init__ method below).

    Properties created with the ``@property`` decorator should be documented
    in the property's getter method.

    Note:
        Do not include the `self` parameter in the ``Args`` section.

    Args:
        param1 : Description of `param1`.
        param2 : Description of `param2`. Multiple
            lines are supported.
        param3 : Description of `param3`.

    Attributes:
        attr1: Description of `attr1`.
        attr2: Description of `attr2`.
    """
    attr1 : str
    attr2 : int
    attr3 : List[str]
    attr4 : List[str]
    attr5 : str
    
    def __init__(self, param1 : str, param2 : int, param3 : List[str]):

        self.attr1 = param1
        self.attr2 = param2
        self.attr3 = param3  #: Comment *inline*

        #: Comment *before* attribute
        self.attr4 = ['attr4']

        self.attr5 = None
        """Docstring *after* attribute"""

    @property
    def readonly_property(self):
        """str: Properties should be documented in their getter method."""
        return 'readonly_property'

    @property
    def readwrite_property(self):
        """:obj:`list` of :obj:`str`: Properties with both a getter and setter
        should only be documented in their getter method.

        If the setter method contains notable behavior, it should be
        mentioned here.
        """
        return ['readwrite_property']

    @readwrite_property.setter
    def readwrite_property(self, value):
        value

    def example_method(self, param1: int, param2: str):
        """Class methods are similar to regular functions.

        Note:
            Do not include the `self` parameter in the ``Args`` section.

        Args:
            param1: The first parameter.
            param2: The second parameter.

        Returns:
            True if successful, False otherwise.

        """
        return True

    def __special__(self):
        """By default special members with docstrings are included.
        
        Special members are any methods or attributes that start with and
        end with a double underscore.

        Do not add a docstring but a simple comment if you don't want it to appear
        """
        pass

    def __special_without_docstring__(self):
        # This does not appear
        pass

    def _private(self):
        """By default private members are included.

        Private members are any methods or attributes that start with an
        underscore and are *not* special.
        
        Do not add a docstring but a simple comment if you don't want it to appear
        """
        pass

    def _private_without_docstring(self):
        # This does not appear
        pass

```
